!= ޥɥ饤Ͻ
!
!= Command line option parser
!
! Authors::   Yasuhiro MORIKAWA
! Version::   $Id: option_parser.f90,v 1.1.1.1 2008-07-30 08:41:33 morikawa Exp $ 
! Tag Name::  $Name: dcpam5-20081008 $
! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
! License::   See COPYRIGHT[link:../../../COPYRIGHT]
!

module option_parser
  !
  != ޥɥ饤Ͻ
  !
  != Command line option parser
  !
  ! <b>Note that Japanese and English are described in parallel.</b>
  !
  ! ޥɥ饤βϽԤޤ. 
  !
  ! Command line options are parsed
  !
  !== Procedures List
  !
  ! OptParseInit  :: ޥɥ饤βϽ
  ! ------------  :: ------------
  ! OptParseInit  :: Parse of command line options

  ! ⥸塼 ; USE statements
  !

  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: STRING  ! ʸ. Strings. 

  ! ʸ ; Declaration statements
  !
  implicit none
  private

  ! ³
  ! Public procedure
  !
  public:: OptParseInit

  ! ѿ
  ! Public variables
  !
  logical, save, public:: option_parser_inited = .false.
                              ! ե饰. 
                              ! Initialization flag
  character(STRING), save, public:: namelist_filename = ''
                              ! NAMELIST ե̾. 
                              ! NAMELIST file name
  logical, save, public:: namelist_flag = .false.
                              ! NAMELIST ե̵ͭ򼨤ե饰. 
                              ! Flag of NAMELIST file specification

  ! ѿ
  ! Private variables
  !
  character(*), parameter:: module_name = 'option_parser'
                              ! ⥸塼̾. 
                              ! Module name
  character(*), parameter:: version = &
    & '$Name: dcpam5-20081008 $' // &
    & '$Id: option_parser.f90,v 1.1.1.1 2008-07-30 08:41:33 morikawa Exp $'
                              ! ⥸塼ΥС
                              ! Module version

  ! INTERFACE ʸ ; INTERFACE statements
  !
  interface OptParseInit
    module procedure OptParseInit
  end interface

contains

  subroutine OptParseInit
    !
    ! option_parser ⥸塼νԤޤ. 
    !
    ! Initialize "option_parser" module. 
    !

    ! ⥸塼 ; USE statements
    !

    ! ʸ
    ! Character handling
    !
    use dc_string, only: StoA

    ! ޥɥ饤
    ! Command line option parser subcontractor
    !
    use dc_args, only: ARGS, &
      & DCArgsOpen,  DCArgsHelpMsg, DCArgsOption, &
      & DCArgsDebug, DCArgsHelp,    DCArgsStrict, DCArgsClose

    ! ʸ ; Declaration statements
    !

    type(ARGS):: arg          ! ޥɥ饤. 
                              ! Command line options

    ! ¹ʸ ; Executable statement
    !

    if ( option_parser_inited ) return
    call InitCheck

    call DCArgsOpen( arg )               ! (out)

    call DCArgsHelpMsg( arg, &           ! (inout)
      & category = 'Title', &            ! (in)
      & msg = 'dcpam main program' )     ! (in)
    call DCArgsHelpMsg( arg, &           ! (inout)
      & category = 'Usage', &            ! (in)
      & msg = './dcpam' // &             ! (in)
      &       ' [Options]' )             ! (in)

    call DCArgsOption( arg, &                 ! (inout)
      & options = StoA('-N', '--namelist'), & ! (in)
      & flag = namelist_flag, &               ! (out)
      & value = namelist_filename, &          ! (out)
      & help = "Namelist filename")           ! (in)

    call DCArgsDebug( arg )  ! (inout)
    call DCArgsHelp( arg )   ! (inout)
    call DCArgsStrict( arg ) ! (inout)

    call DCArgsClose( arg )  ! (inout)

    option_parser_inited = .true.
  end subroutine OptParseInit

  subroutine InitCheck
    !
    ! ¸⥸塼νå
    !
    ! Check initialization of dependency modules

    ! ¹ʸ ; Executable statement
    !


  end subroutine InitCheck

!!$  subroutine InitDepmod
!!$    !
!!$    ! ¸⥸塼ν
!!$    !
!!$    ! Initialize dependency modules
!!$
!!$    ! ¹ʸ ; Executable statement
!!$    !
!!$
!!$  end subroutine InitDepmod

end module option_parser
